/*Copyright (c) 2003 The Regents of the University of California.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. All advertising materials mentioning features or use of this software
   must display the following acknowledgement:
     This product includes software developed by the University of
     California, Los Angeles and its contributors.
4. Neither the name of the University nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE. */

/* File that contains some constants rate limit
   component. Rate limit is imposed on teh aggregate
   flow to IP address */

#ifndef __RL_STATS_H
#define __RL_STATS_H

#include "constants.h" 

struct rl_stats
{
  /* Allowed Bytes per second */
  int rate_limit; 
};

/* Function prototypes, refer to implementation for descriptions */
int rl_clean(struct rl_stats*);
int rl_compare(unsigned int*, unsigned int*);
unsigned long rl_hash1(unsigned int*, unsigned long);
unsigned long rl_hash2(unsigned int*, unsigned long);
int find_rate_limit(char*);
int find_rate_limit_num(unsigned int);
long add_rate_limit(char*);
long add_rate_limit_num(unsigned int);
void update_rate_limit(char*, int);
void update_rate_limit_num(unsigned int, int);
void rlhash_cleanup(int);
void initialize_rl();
void delete_rate_limit(char*);
void delete_rate_limit_num(unsigned int);

#endif



