/*Copyright (c) 2003 The Regents of the University of California.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. All advertising materials mentioning features or use of this software
   must display the following acknowledgement:
     This product includes software developed by the University of
     California, Los Angeles and its contributors.
4. Neither the name of the University nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE. */

/* File that contains some constants that 
   all other files use */

#ifndef __CONSTANTS_H
#define __CONSTANTS_H

#define FALSE 0
#define TRUE 1

/* Hash constants */
#define NOT_FOUND -1
#define EMPTY 0
#define VALID 1
#define DELETED 2

/* Packet direction, OUT means sent from internal network
   to outside host, IN means received from outside host for internal
   network */
enum direction {IN, OUT, NONE};
enum pack_type{SYN, SYNACK, ACK, DP, FIN, FINACK, RST, DNS, DNSACK, NTP, STREAM};

/* Which part of statistics is queried, this is for kernel hashes */
#define RL             0
#define SENT_PACKETS   1
#define SENT_BYTES     2
#define REC_PACKETS    3
#define REC_BYTES      4
#define DROP_PACKETS   5
#define DROP_BYTES     6
#define PROTOCOL       7
#define SENT_BYTES_SEC 8
#define GOOD_BYTES     9
#define GOOD_BYTES_SEC 10
#define FORWARDED      11
#define GOODPUT        12
#define ATT_PACKETS    13
#define ATT_BYTES      14
#define FW_PACKETS     15
#define FW_BYTES       16
#define SYNS           17

/* Cumulative statistics */
#define GOOD_DROP      0
#define GOOD_PASS      1
#define BAD_DROP       2
#define BAD_PASS       3

/* Size of kernel statistics queue */
#define STAT_SIZE     20

#define SO_REUSEPORT 15

/* Generic reply packet */
#define MAX_TCP_HEADER	       160
#define TCP_HEADER_LEN          20
#define IP_HEADER_LEN           5

#endif







